﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace AdventOfCode2023.Day1
{
    public class Day1_1 : DayBase
    {
        string input = string.Empty;
        Regex singleDigit = new Regex(@"\d");

        public Day1_1()
        {
            input = GetInput("Day1.txt");
        }

        public Day1_1(string testInput)
        {
            input = testInput;
        }

        public override string Execute()
        {
            var segmentedInput = input.Split("\r\n");
            int calibrationSum = 0;

            foreach (var segment in segmentedInput)
            {
                if (!singleDigit.IsMatch(segment))
                {
                    return $"segment: {segment} does not contain a digit!";
                }

                var matches = Regex.Matches(segment, @"\d");
                if (int.TryParse(string.Join("", matches.FirstOrDefault()?.Value ?? "", matches.LastOrDefault()?.Value ?? ""), out var calibrationValue))
                {
                    calibrationSum += calibrationValue;
                }
                else
                {
                    return $"Could not parse segment: {segment} to int!";
                }
            }

            return calibrationSum.ToString();
        }
    }
}
