﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Xml.Serialization;

namespace AdventOfCode2023.Day4
{
    public class Day4_1 : DayBase
    {
        string input = string.Empty;

        Regex rxWinningNumbers = new Regex(@"^.+?: (?<numbers>[ \d]*) $");
        Regex rxDrawnNumbers = new Regex(@"^ (?<numbers>[ \d]*)$");

        public Day4_1()
        {
            input = GetInput("Day4.txt");
        }

        public Day4_1(string testInput)
        {
            input = testInput;
        }

        public override string Execute()
        {
            var lines = input.Split("\r\n");

            int points = 0;

            foreach (var line in lines)
            {
                var cardParts = line.Split('|');

                string winningSequence = rxWinningNumbers.Match(cardParts[0]).Groups["numbers"].Value;
                string drawnSequence = rxDrawnNumbers.Match(cardParts[1]).Groups["numbers"].Value;

                List<int> winningNumbers = new List<int>();
                List<int> drawnNumbers = new List<int>();

                for (int i = 0; i < winningSequence.Length; i += 3)
                {
                    winningNumbers.Add(int.Parse(winningSequence.Substring(i, 2).Trim()));
                }
                for (int i = 0; i < drawnSequence.Length; i += 3)
                {
                    drawnNumbers.Add(int.Parse(drawnSequence.Substring(i, 2).Trim()));
                }

                var intersections = drawnNumbers.Intersect(winningNumbers).ToList();

                points += intersections.Count > 0 ? (0b1 << (intersections.Count - 1)) : 0;
            }

            return points.ToString();
        }
    }
}
